;Eintrge in 'rsx'-Sprungtabelle

 jp cursor
 jp getic
 jp icon
 jp deficn
 jp fill

;Eintr. in 'table' der RSX-Befehle

 defm "CURSO"
 defb "R"+#80
 defm "GETICO"
 defb "N"+#80
 defm "ICO"
 defb "N"+#80
 defm "DEFICO"
 defb "N"+#80
 defm "FIL"
 defb "L"+#80

;Assemblerlist. der Befehlsroutinen

cursor: ;Routine fr Cursorsteuerung
 push hl                  ;HL retten
 ld hl,(v1)            ;X-Wert in HL
 ld bc,(orx)             ;X0 nach BC
 sbc hl,bc        ;X0 von X abziehen
 ld (v1),hl        ;X-Wert eintragen
 ex de,hl            ;X-Wert nach DE
 ld hl,(v2)            ;Y-Wert in HL
 ld bc,(ory)             ;Y0 nach BC
 sbc hl,bc        ;X0 von X abziehen
 ld (v2),hl        ;X-Wert eintragen
 ld bc,0      ;Cursor-Stepping auf 0
 jp w8     ;Anfangen mit Darstellung
w2: push bc  ;Cursor-Stepping retten
 call ktest         ;Taste gedrckt?
 pop bc              ;Stepping holen
 jp z,kn ;keine Taste? => Step auf 0
 inc bc       ;Stepping um 2 erhhen
 inc bc   ;(fr hhere Auflsung des
            ;Cursors 2.inc bc entf.)
 pop hl      ;Y-Wert vom Stack holen
 pop de      ;X-Wert vom Stack holen
 push bc            ;Stepping retten
 call #bd19         ;MC WAIT FLYBACK
 call putcur;Cursor entf.(2.Invert.)
 call ktf      ;Feuer/Copy gedrckt?
 pop bc              ;Stepping holen
 pop hl                     ;Y holen
 pop de                     ;X holen
 jp z,w3     ;nicht gedrckt? weiter
 jp w4                      ;an Ende
w3: push hl                ;Y retten
 push bc            ;Stepping retten
 call ktu   ;Taste 'runter gedrckt?
 pop bc              ;Stepping holen
 pop hl                     ;Y holen
 jp z,w5     ;nicht gedrckt? weiter
 add hl,bc   ;Stepping zu Y addieren
 jp w6      ;Abfrage 'hoch' berspr.
w5: push hl  ;Abfrage 'hoch',wie fr
 push bc                    ;'runter
 call ktd  ;Taste fr hoch gedrckt?
 pop bc
 pop hl
 jp z,w6
 sbc hl,bc     ;ja? ==> Y=Y-Stepping
w6: push hl     ;Abfrage fr 'links'
 push bc
 call ktl ;Taste fr links gedrckt?
 pop bc
 pop hl
 jp z,w7
 ex de,hl            ;X-Wert nach HL
 sbc hl,bc     ;ja? ==> X=X-Stepping
 ex de,hl     ;X-Wert zurck nach DE
 jp w8    ;Abfrage 'rechts' berspr.
w7: push hl      ;Abfrage fr rechts
 push bc
 call ktr  ;Taste 'rechts' gedrckt?
 pop bc
 pop hl
 jp z,w8
 ex de,hl
 add hl,bc    ;Ja? dann X=X+Stepping
 ex de,hl
w8: push bc         ;Stepping retten
 push de                   ;X retten
 ex de,hl      ;X nach HL; Y nach DE
 ld bc,639                  ;BC=Xmax
 sbc hl,bc                 ;X=X-Xmax
 ex de,hl          ;Y zurck nach HL
 bit 7,d          ;Ergebnis negativ?
 pop de                     ;X holen
 pop bc              ;Stepping holen
 jp nz,ww0   ;X-Xmax<X0? dann weiter
 ld de,639             ;sonst X=Xmax
ww0: push hl               ;Y retten
 push bc            ;Stepping retten
 ld bc,399                  ;BC=Ymax
 sbc hl,bc                 ;Y=Y-Ymax
 bit 7,h          ;Ergebnis negativ?
 pop bc              ;Stepping holen
 pop hl                     ;Y holen
 jp nz,ww    ;Y-Ymax<Y0? dann weiter
 ld hl,399             ;sonst Y=Ymax
ww: bit 7,h    ;negative Koordinate?
 jp z,ww1    ;Y positiv? dann weiter
 ld hl,0                  ;sonst Y=0
ww1: bit 7,d    ;Koordinate negativ?
 jp z,ww3    ;X positiv? dann weiter
 ld de,0                  ;sonst X=0
ww3: push de               ;X retten
 push hl                   ;Y retten
 push de                   ;X retten
 push hl                   ;Y retten
 push bc            ;Stepping retten
 ld (v1),de             ;X nach XPOS
 ld (v2),hl             ;Y nach YPOS
 call putcur ;Cursor darst.(invert.)
 pop bc              ;Stepping holen
 jp w2                ;weiter bei w2
w4: ld hl,(v1) ;X-Koordinate nach HL
 ld bc,(orx)       ;X-Origin nach BC
 add hl,bc                   ;X=X+X0
 ld (v1),hl  ;X-Koordinate schreiben
 ld hl,(v2);Y-Koordinate berichtigen
 ld bc,(ory)
 add hl,bc
 ld (v2),hl
 pop hl             ;Stack aufrumen
w4a: call #bd19 ;Tastaturbuf. leeren
 ret nc    ;schon leer? dann fertig!
 jp w4a        ;sonst nochmal leeren

kn:      ;wenn keine Taste gedrckt:
 ld bc,0           ;Stepping lschen
 jp w2           ;und wieder nach w2

v1: equ #b697    ;XPOS ;CPC 464:B32C
v2: equ #b699    ;YPOS          B32E
smode: equ #b7c3 ;Bildschirmmode
                 ;CPC 464:B1C8
orx: equ #b693   ;Origin X-Wert
                 ;CPC 464:B328
ory: equ #b695   ;Y-Wert ;B32A

mshift:push bc   ;Bitpos. nach links
 push de           ;BC und DE retten
 xor a                ; Akku lschen
 ld d,a               ;und D lschen
 ld b,4                ;4 Durchgnge
msh1: sla c   ;Maske in C nach links
 rla           ;Carry in Akku rollen
 sla c     ;Maske nochmal nach links
 rlc d        ;und Carry in D rollen
 djnz msh1          ;und alles 4 mal
 or d         ;Akku und D verknpfen
 pop de      ;DE und BC wieder holen
 pop bc
 ld c,a;und neue Maske wieder nach C
 ret                     ;und zurck

putcur:    ;Routine fr Cursordarst.
                     ;(Invertierung)
 srl h            ;DE durch 2 teilen
 rr l
 ld a,(smode)     ;Bildmodus in Akku
 push af               ;Modus retten
 ld a,2          ;Mode 2 vortuschen
 ld (smode),a
putcu0:             ;Bildadr. in HL,
            ;Bytemaske fr Pkt. in C
 call #bc1d        ;SCR DOT POSITION
 pop af         ;Originalmodus holen
 ld (smode),a ; und wiederherstellen
 ld de,curmat;Adr.d.Curs.matr. in DE
 ld b,8     ;Lnge der Matrix nach B
 push bc                  ;BC retten
 ld bc,8   ;Lnge der Matrix nach BC
 ld a,(smode)          ;Modus nach A
 or a ;=0?
 jp z,putcuc ;dann weiter fr Mode 0
 ex de,hl  ;sonst HL und DE tauschen
 add hl,bc ;HL auf Matrix fr Mode 1
 ex de,hl        ;und zurcktauschen
 dec a                         ;A=1?
 jp z,putcua ;dann weiter fr Mode 1
 ex de,hl    ;sonst nochmal tauschen
 add hl,bc ;HL auf Matrix fr Mode 2
 ex de,hl        ;und zurcktauschen
 pop bc                    ;BC holen
putcb1:ld a,(de);Byte ausMat.in Akku
 push bc                  ;BC retten
 ld b,0                   ;B lschen
putcb2:sla a        ;Akku nach links
 rl b         ;und Carry in B rollen
 srl c       ;C nach rechts schieben
 jp nc,putcb2     ;bis Carrybertrag
 push af      ;Akku und Flags retten
 ld a,b                   ;B in Akku
 xor (hl) ;dann mit Bildadr. invert.
 ld (hl),a    ;und in Bild schreiben
 pop af                    ;AF holen
 inc hl       ;Bildschirmadr erhhen
 xor (hl)  ;Akku mit Bildadr invert.
 ld (hl),a    ;und in Bild schreiben
 dec hl  ;Bildadr wieder verkleinern
 call #bc26           ;SCR NEXT LINE
 pop bc                    ;BC holen
 inc de           ;Matrixadr erhhen
 djnz putcb1   ;und Schleife bis B=0
 ret                        ;fertig!

putcua:pop bc    ;Routine fr Mode 1
 call mshift  ;Bitmaske an Mode anp.
putca1:ld a,(de);Byte a. Matrix Akku
 push bc                  ;BC retten
 ld b,0                   ;B lschen
putca2:sla a        ;Akku nach links
 rl b         ;und Carry in B rollen
 srl c       ;C nach rechts schieben
 jp nc,putca2     ;bis Carrybertrag
 sla b    ;B um 4 Stellen nach links
 sla b
 sla b
 sla b
 push af      ;Akku und Flags retten
 ld a,b                   ;B in Akku
 xor (hl) ;dann mit Bildadr. invert.
 ld (hl),a    ;und in Bild schreiben
 pop af                    ;AF holen
 inc hl       ;Bildschirmadr erhhen
 xor (hl)  ;Akku mit Bildadr invert.
 ld (hl),a   ;und sin Bild schreiben
 dec hl  ;Bildadr wieder verkleinern
 call #bc26           ;SCR NEXT LINE
 pop bc                    ;BC holen
 inc de           ;Matrixadr erhhen
 djnz putca1   ;und Schleife bis B=0
 ret                        ;fertig!

putcuc:pop bc     ;Darst. fr Mode 0
 call mshift       ;Bitmaske an Mode
                           ;anpassen
 call mshift
putcc1:ld a,(de)    ;Byte aus Matrix
                            ;in Akku
 push bc                  ;BC retten
 ld b,0                   ;B lschen
putcc2:sla a        ;Akku nach links
 rl b         ;und Carry in B rollen
 srl c       ;C nach rechts schieben
 jp nc,putcc2            ;Weiter bis
                      ;Carrybertrag
 sla b    ;B um 6 Stellen nach links
 sla b
 sla b
 sla b
 sla b
 sla b
 push af      ;Akku und Flags retten
 ld a,b                   ;B in Akku
 xor (hl) ;dann mit Bildadr. invert.
 ld (hl),a    ;und in Bild schreiben
 pop af                    ;AF holen
 inc hl       ;Bildschirmadr erhhen
 xor (hl)  ;Akku mit Bildadr invert.
 ld (hl),a   ;und sin Bild schreiben
 dec hl  ;Bildadr wieder verkleinern
 call #bc26           ;SCR NEXT LINE
 pop bc                    ;BC holen
 inc de           ;Matrixadr erhhen
 djnz putcc1   ;und Schleife bis B=0
 ret                        ;fertig!

curmat:      ;die Cursormatrizen fr
curma0:                   ;Mode 0...
 defb #80,#80,#c0,#c0
 defb #40,#40,#40,#00
curma1:                ;...Mode 1...
 defb #80,#c0,#e0,#f0
 defb #e0,#a0,#10,#10
curma2:              ;...und Mode 2.
 defb #80,#e0,#f8,#fe
 defb #f8,#d8,#8c,#06

ktf:           ;Feuer/Copy gedrckt?
 ld a,76       ;Tastennummer in Akku
 call #bb1e             ;KM TEST KEY
 ret nz       ;gedrckt? dann zurck
 ld a,9  ;sonst nchste Tastennummer
 call #bb1e             ;KM TEST KEY
 ret                     ;und zurck
ktu:                    ;Taste hoch?
 ld a,72
 call #bb1e
 ret nz
 ld a,0
 call #bb1e
 ret
ktd:                 ;Taste 'runter?
 ld a,73
 call #bb1e
 ret nz
 ld a,2
 call #bb1e
 ret
ktl:                   ;Taste links?
 ld a,74
 call #bb1e
 ret nz
 ld a,8
 call #bb1e
 ret
ktr:                  ;Taste rechts?
 ld a,75
 call #bb1e
 ret nz
 ld a,1
 call #bb1e
 ret
ktest:    ;testet, ob irgendeine der
          ;Steuertasten gedrckt ist
 ld a,9
 call #bb1e
 ret nz
 ld a,76
 call #bb1e
 ret nz
 xor a
 call #bb1e
 ret nz
 ld a,72
 call #bb1e
 ret nz
 ld a,2
 call #bb1e
 ret nz
 ld a,73
 call #bb1e
 ret nz
 ld a,1
 call #bb1e
 ret nz
 ld a,75
 call #bb1e
 ret nz
 ld a,8
 call #bb1e
 ret nz
 ld a,74
 call #bb1e
 ret


getic:         ;Liest mit dem Cursor
                       ;ein Icon ein
 cp 1                  ;1 Parameter?
 jp m,opmis                ;weniger?
                  ;'Operand missing'
 jp nz,imparg                 ;mehr?
                ;'Improper Argument'
getic0:ld a,(maxmen) ;Anz. der Icons
 or a                           ;=0?
 jp z,giout               ;dann Ende
 ld (mpunkt),a ;sonst Akku in Zhler
getic1:call cursor   ;Cursor steuern
 ld de,(v1)              ;XPOS in DE
 xor a                 ;Akku lschen
 ld hl,xtab ;HL auf Tab. der X-Werte
xtest: ld c,(hl)  ;BC aus Tab. lesen
 inc hl
 ld b,(hl)
 inc hl ;Zeiger auf nchsten Eintrag
 ex de,hl                ;XPOS in HL
 sbc hl,bc        ;XPOS-Tabellenwert
 jp m,xweit            ;XOPS<X-Wert?
                       ;kein Treffer
 ex de,hl       ;XPOS wieder nach DE
 xor a
 cp h                          ;H=0?
 jp nz,xweit            ;dann Fehler
 ld a,47         ;Iconlnge-1 nach A
 cp l            ;XPOS-Xwert<=Lnge?
 jp m,xweit       ;dann kein Treffer
 ld de,(v2)            ;YPOS nach DE
 ld bc,510   ;Lnge d.Tab.-2 nach BC
 add hl,bc ;Zeiger auf Eint. in YTAB
ytest: ld c,(hl)  ;Test des Y-Wertes
 inc hl               ;wie bei xtest
 ld b,(hl)
 ex de,hl
 push hl         ;BC und HL tauschen
 push bc
 pop hl
 pop bc
 sbc hl,bc
 jp m,yweit
 xor a
 cp h
 jp nz,yweit
 ld a,47
 cp l
 jp m,yweit
 ld a,(mpunkt);Treffer: Counter in B
 ld b,a
 ld a,(maxmen);Anzahl der Icons in A
 sub b              ;Differenz in BC
 ld c,a
 ld b,0
 ld hl,iclst  ;Adr.der Iconnr. in HL
 add hl,bc       ;Zeiger auf Iconnr.
 ld a,(hl)          ;Iconnr. in Akku
giout: ld l,(ix+0)   ;und als Param.
                        ;zurckgeben
 ld h,(ix+1)
 ld (hl),a
 ret                         ;fertig

xweit:
 ex de,hl      ;Adr. von XTAB  in HL
 ld de,(v1)    ;XPOS wieder einlesen
 ld a,(mpunkt)         ;Zhler lesen
 dec a            ;Zhler vermindern
 jp z,getic0     ;=0? dann von vorne
 ld (mpunkt),a        ;Zhler zurck
 jp xtest         ;und weiter testen

yweit:
 ex de,hl    ;Adresse von Ytab in HL
 ld bc,511   ;wieder in Xtab wandeln
 ld de,(v2)       ;XPOS wieder in de
 ld a,(mpunkt)       ;Zhler in A...
 dec a                ;...vermindern
 jp z,getic0   ;und von vorne wenn 0
 jp xtest     ;sonst nchster X-Wert

mpunkt:defs 1                ;Zhler
maxmen:defs 1  ;Anz. der darg. Icons
xtab: defs 512  ;Tabelle der X-Werte
ytab: defs 512 ; Tabelle der Y-Werte
ictab: defs 256 ;Tabelle der Iconnr.
icadr: defs 512 ;Tabelle der Iconad.
iclst: defs 256  ;Liste  darg. Icons
iccnt: defs 1 ;Anzahl der def. Icons
 defs 1                ;und Nullbyte

icon:       ;Stellt das Icon mit der
               ;Nummer n an X,Y dar.
 cp 3                  ;3 Parameter?
 jp m,opmis
 jp nz,imparg
 ld a,(maxmen)    ;Anz.d.dargest.Ics
                             ;nach A
 cp #ff                  ;schon 255?
 jp z,imparg            ;dann Fehler
 ld hl,ictab ;Adr.d.Icontab. nach HL
 ld a,(iccnt);Anz.d.def.Icons nach A
 or a                         ;  =0?
 jp z,imparg            ;dann Fehler
 ld b,a               ;Anzahl nach B
 ld a,(ix+0) ;Nr. darzust.Ics nach A
ica: inc hl      ;auf ersten Eintrag
 cp (hl)              ;In der Liste?
 jp z,icb               ;dann weiter
 djnz ica     ;nchste Stelle prfen
 jp imparg  ;nicht in Liste? Fehler!
icb: ld c,a   ;Nr. des Icons nach BC
 ld b,0
 ld hl,icadr  ;Adresstabelle nach HL
 add hl,bc      ;Iconnummer addieren
 add hl,bc        ;2mal, weil 2 Byte
 ld e,(hl)  ;Adr.d.Icons aus Tabelle
 inc hl                       ;in DE
 ld d,(hl)
 push de         ;und Adresse retten
 ld e,(ix+2)      ;Koordinaten holen
 ld d,(ix+3)
 ld l,(ix+4)
 ld h,(ix+5)
 srl h        ;Y-Wert durch 2 teilen
 rr l
 ld a,(smode) ;Bildschirmmodus holen
 push af                 ;und retten
 ld a,2          ;Mode 2 vortuschen
 ld (smode),a
 call #bc1d        ;SCR DOT POSITION
 pop af       ;Bildschirmmodus holen
 ld (smode),a  ;und wieder einsetzen
 pop de           ;Iconadresse holen
 ex de,hl        ;DE und HL tauschen
 ld b,24            ;Zeilenzahl in B
icc: push bc               ;B retten
 push de       ;Bildschirmadr retten
 ld bc,6                     ;6 Byte
 ldir     ;in Bildspeicher schreiben
 pop de              ;Bildadr. holen
 pop bc                     ;B holen
 ex de,hl     ;Bildschirmadr nach HL
 call #bc26           ;SCR NEXT LINE
 ex de,hl   ;Adressen zurcktauschen
 djnz icc        ;und weiter bis B=0
 ld hl,iclst      ;Iconliste nach HL
 ld a,(maxmen) ;Anz.d.dge.Ics nach A
 inc a                 ;um 1 erhhen
 ld (maxmen),a  ;und zurckschreiben
 ld c,a     ;BC=Anz. d. dgest. Icons
 ld b,0
 dec bc                          ;-1
 add hl,bc              ;neue Pos.in
                    ;Iconlst nach HL
 ld a,(ix+0)       ;Nummer des Icons
 ld (hl),a                ;eintragen
 ld hl,xtab     ;Adresse der X-Werte
 add hl,bc   ;neues Icon +2* Iconnr.
 add hl,bc
 ld a,(ix+4);und X-Wert fr neu Icon
 ld (hl),a                ;eintragen
 inc hl
 ld a,(ix+5)
 ld (hl),a
 ld hl,ytab     ;Tabelle fr Y-Werte
 add hl,bc
 add hl,bc
 ld a,(ix+2)   ;und Y-Wert eintragen
 ld (hl),a
 inc hl
 ld a,(ix+3)
 ld (hl),a
 ret                        ;fertig!

mpatch:         ;patcht SCR SET MODE
 ld hl,#bc0e    ;HL auf SCR SET MODE
 ld de,mpr2     ;DE auf Patchroutine
 ld bc,3                     ;3 Byte
 ldir                      ;kopieren
 ld a,#c3           ;Obcode fr 'JP'
 ld (#bc0e),a     ;nach SCR SET MODE
 ld hl,mpr  ;Adresse d. Patchroutine
 ld (#bc0f),hl;in SCR SET MODE eint.
 ret                        ;fertig!
mpr:                   ;Patchroutine
 push af                ;Mode retten
 xor a                 ;Akku lschen
 ld (maxmen),a ;und Tab. d. dargest.
               ;Icons initialisieren
 pop af                  ;Mode holen
mpr2: defs 3  ;Hier kommt der Sprung
          ;auf die alte SCR SET MODE
                        ;Routine hin

deficn:cp 2            ;2 Parameter?
 jp m,opmis
 jp nz,imparg
 ld a,(iccnt)    ;Anz. d. def. Icons
 cp #ff                  ;schon 255?
 jp z,imparg            ;dann Fehler
 ld l,(ix+0)               ;Adr. der
               ;Iconstringsparameter
 ld h,(ix+1)                ;nach HL
 ld a,(hl)        ;Lnge des Strings
 cp 145                       ;>144?
 jp p,imparg            ;dann Fehler
 ld c,a         ;sonst Lnge nach BC
 ld b,0
 push bc         ;Stringlnge retten
 ld a,(iccnt)        ;Iconanz. holen
 ld c,a                  ;und nach c
 or a                     ;Anzahl=0?
 jp z,defic1   ;dann  nicht in Liste
 ld hl,ictab    ;Icontabelle nach HL
 ld a,(ix+2)      ;Iconnummer nach A
 cpir           ;in Liste enthalten?
 jp nz,defic1    ; nein? dann weiter
 ld c,(ix+2)     ;Iconnummer nach BC
 ld b,0
 ld hl,icadr  ;Iconadr. Tab. nach HL
 add hl,bc   ;Zeiger auf Iconeintrag
 add hl,bc
 ld e,(hl)   ;Adr. des Icons nach DE
 inc hl
 ld d,(hl)
 ex de,hl        ;DE und HL tauschen
 jp defic2 ;und Speicherreservierung
                       ;berspringen
defic1:ld hl,(himem)
               ;Himem-Zeiger nach HL
 ld bc,144 ;Lnge d.Platzes fr Icon
 sbc hl,bc                 ;Abziehen
 push hl   ;und neuen Zeiger nach DE
 pop de                      ;und HL
 push hl              ;Zeiger retten
 call getmem      ;Platz reservieren
 pop hl                ;Zeiger holen
defic2:pop bc     ;Stringlnge holen
 push hl              ;Zeiger retten
 ld l,(ix+0)    ;HL auf Stringdeskr.
 ld h,(ix+1)
 inc hl           ;HL auf Stringadr.
 ld e,(hl)       ;Stringadr. nach DE
 inc hl
 ld d,(hl)
 pop hl        ; Zeiger wieder holen
 push hl            ;Iconadr. retten
 ex de,hl        ;DE und HL tauschen
 ldir      ;Icon in Bereich kopieren
 pop de              ;Iconadr. holen
 ld hl,icadr;Adr.d. Adr.tab. nach HL
 ld c,(ix+2)  ;Nr. des Icons nach BC
 ld b,0
 add hl,bc  ;und 2mal zu HL addieren
 add hl,bc
 ld (hl),e     ;Adresse des Icons in
 inc hl           ;Tabelle eintragen
 ld (hl),d
 ld a,(iccnt)      ;Anzahl der Icons
 inc a                      ;erhhen
 ld (iccnt),a   ;und zurckschreiben
 ld c,a              ;Anzahl nach BC
 ld hl,ictab ;Tab. d.Iconnr. nach HL
 add hl,bc   ;Zeiger auf neuen Platz
 ld a,(ix+2)         ;und Iconnummer
 ld (hl),a                ;eintragen
 ret                        ;fertig!

fill:       ; Fllt den Bildspeicher
 cp 1                  ;1 Parameter?
 jp m,opmis
 jp nz,imparg
 ld c,(ix+0)        ;Fllbyte nach C
 ld hl,#c000 ;Anfangsadr. d. Bildsp.
   ;nach HL
 ld de,#50c8;Breite und Hhe nach DE
 jp #bc47             ;SCR FLOOD BOX


 ;Diese Routine mu~ in 'MEMFRE' vor
 ;'LD HL,WINADR' eingefgt werden

 ld hl,icadr      ;Icon-Adr. nach HL
 xor a    ;Iconzhler initialisieren
memfr1:ld c,(hl);Adr.aus Tab.nach BC
 inc hl
 ld b,(hl)
 inc hl
 push hl             ;Adresse retten
 ld hl,144        ;Iconlnge nach HL
 add hl,bc  ;Adr.hinter Icon nach HL
 sbc hl,de      ;=Adr. des Bereichs?
 pop hl   ;   Adr. der Tabelle holen
 jp z,pushic   ;wenn =:Icon hochkop.
 dec a          ;sonst nchstes Icon
 jp nz,memfr1


       ;Diese Routine gehrt auch zu
                        ;MEMFRE. Sie
 ;mu~ aber hinter der MEMFRE-Routine
   ;eingefgt werden, da sie nur als
   ;Unterprogramm angesprungen wird.

pushic:     ;kopiert ein Icon 'hoch'
 ld bc,144        ;Iconlnge nach BC
 push hl          ;Adresstab. retten
 ld de,(wadr)  ;Bereichsadr. nach DE
 ld hl,(wlaeng)   ;Ber.lnge nach HL
 add hl,de      ;Zeiger nach Bereich
 dec de             ;DE auf Iconende
 dec hl         ;HL auf Bereichsende
 ex de,hl        ;DE und HL tauschen
 lddr               ;Window kopieren
 inc hl   ;neue Bereichsadr. nach HL
 inc de       ;neue Iconadr. nach DE
 ld (wadr),hl;Bereichsadr. eintragen
 pop hl         ;Adresstabelle holen
 dec hl  ;neue Iconadresse eintragen
 ld (hl),d
 dec hl
 ld (hl),e
 jp memfr0       ;und nochmal testen



 ;Der 'RET' im Initialisierungsteil
 ;der RSX-Befehle mu~ ersetzt werden

 jp mpatch

